#ifndef GLOBAL_USER_H__
#define GLOBAL_USER_H__

#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

/*---------------  Global Definition For SAADC ---------------- */
#define  ADC_USE_CALLBACK
#define  IDEAL_3_3V_BASE 
//#define  IDEAL_2_2V_BASE

/*---------------  Global Definition For FreeRTOS  ---------------- */
//#define ENABLE_RTOS_SERVICE

#define ENABLE_RTOS_TEST
#define TASK_DELAY        200           /**< Task delay. Delays a LED0 task for 200 ms */
#define TIMER_PERIOD      1000          /**< Timer period. LED1 timer will expire after 1000 ms */
 

#define LOOPTIMUS_STACK_SIZE               256
#define LOOPTIMUS_PRIORITY                 4

#define USBD_STACK_SIZE                   256 
#define USBD_PRIORITY                      3

#define MEMORY_STACK_SIZE   200
#define MEMORY_OPERATION_TASK_PRIORITY   2
#define LED_BLINK_INTERVAL 800

/**
 * The maximum delay inside the USB task to wait for an event.
 */
#define USB_THREAD_MAX_BLOCK_TIME portMAX_DELAY

/*----------------- Global Variable For SAADC ----------------*/


/*----------------- Global Variable For Battery Monitoring  ----------------*/
// below intervals are in milliseconds
#define LED_BLINK_INTERVAL              800
#ifndef BLE_MIDI_SUPPORT
#define FLASH_PAGE_ERASE_INTERVAL       10
#endif
#define FLASH_WRITE_TIMER_INTERVAL      1000
#define DISPLAY_UPDATE_INTERVAL         5
#define BAT_OPERATION_INTERVAL          997
#define LOW_BAT_BLINK_INTERVAL          700
#define DELAY_TIMER_MS                  100
/*----------------- Global function For SAADC ----------------*/
void Check_button_status(int gadc_button_value);
void get_adc_sample(int channel);
int measure_battery_volt();
void BatLowVoltage_StartTimer(void);
void BatLowVoltage_StopTimer(void);

/*---------------- Global function for usbd -------------*/
void usbd_thread(void * arg);
void create_usbd_thread (void);
/*----------------- Global function For timer ----------------*/
void timer_init(void);

/* -------------------- Looptimus MINI Plus Global funciton ----------*/
void looptimus_mini_plus_app_thread(void * arg);
void init_loop_mini(void);
int read_button_at_PoS (void);
int read_ext_pedal_value(void);
int digitalSmooth(int rawIn, int *sensSmoothArray);

#ifdef __cplusplus
}
#endif

#endif 