/**
 * Copyright (c) 2019, Nordic Semiconductor ASA
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form, except as embedded into a Nordic
 *    Semiconductor ASA integrated circuit in a product or a software update for
 *    such product, must reproduce the above copyright notice, this list of
 *    conditions and the following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *
 * 3. Neither the name of Nordic Semiconductor ASA nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * 4. This software, with or without modification, must only be used with a
 *    Nordic Semiconductor ASA integrated circuit.
 *
 * 5. Any software provided in binary form under this license must not be reverse
 *    engineered, decompiled, modified and/or disassembled.
 *
 * THIS SOFTWARE IS PROVIDED BY NORDIC SEMICONDUCTOR ASA "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, NONINFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL NORDIC SEMICONDUCTOR ASA OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
 
 /** 

Modified by u-blox 2019

*/

#ifndef LOOPTIMUS_MINI_PLUS_BOARD_H
#define LOOPTIMUS_MINI_PLUS_BOARD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "nrf_gpio.h"

#define LEDS_NUMBER 4

#define BAT_RED_LED    NRF_GPIO_PIN_MAP(0, 15)
#define BAT_GREEN_LED  NRF_GPIO_PIN_MAP(0, 27)
#define BLE_LED        NRF_GPIO_PIN_MAP(0, 6)
//#define ISR_GPIO       NRF_GPIO_PIN_MAP(1, 1) 
#define BAT_CHARG      NRF_GPIO_PIN_MAP(0, 23)
#define BAT_INT        NRF_GPIO_PIN_MAP(0, 13) 
#define TEST_7        NRF_GPIO_PIN_MAP(1, 2)
//#define LED_1          NRF_GPIO_PIN_MAP(0,13)	// RED
//#define LED_2          NRF_GPIO_PIN_MAP(1,0)	// BLUE

#define LEDS_ACTIVE_STATE 1

#define LEDS_LIST {BAT_RED_LED,BAT_GREEN_LED,BLE_LED,TEST_7}

#define LEDS_INV_MASK  LEDS_MASK

#define BUTTONS_NUMBER 4
/*
#define BUTTON_0       NRF_GPIO_PIN_MAP(0,30) 
#define BUTTON_1       NRF_GPIO_PIN_MAP(1,1)   
#define BUTTON_2       NRF_GPIO_PIN_MAP(0,2)  
#define BLE_MODE_DETECT  NRF_GPIO_PIN_MAP(0,29) 
*/

#define BUTTON_0       NRF_GPIO_PIN_MAP(1,1) 
#define BUTTON_1       NRF_GPIO_PIN_MAP(0,2)   
#define BUTTON_2       NRF_GPIO_PIN_MAP(0,30)  
#define BLE_MODE_DETECT  NRF_GPIO_PIN_MAP(0,29) 

#define BUTTON_PULL    NRF_GPIO_PIN_PULLUP
#define BUTTON_DOWN    NRF_GPIO_PIN_PULLDOWN

#define BUTTONS_ACTIVE_STATE 0

#define BUTTONS_LIST {BUTTON_0, BUTTON_1, BUTTON_2,BLE_MODE_DETECT}


#define BSP_BUTTON_0   BUTTON_0
#define BSP_BUTTON_1   BUTTON_1
#define BSP_BUTTON_2   BUTTON_2
#define BSP_BUTTON_3   BLE_MODE_DETECT

#define  BLE_MODE_DETECT_BUTTON_IDX                3

#define BAT_RED_LED_NUM    0//1
#define BAT_GREEN_LED_NUM  1//2
#define BLE_LED_NUM        2//3
#define BAT_CHARG_NUM      3 //4

/* Analog Channels */
#define SAADC_BTN_PIN    NRF_SAADC_INPUT_AIN1 
#define BAT_VOLT_PIN     NRF_SAADC_INPUT_AIN7
#define EXT_PEDAL_PIN    NRF_SAADC_INPUT_AIN0

/* I2C channel */
#define BAT_SCL_PIN             NRF_GPIO_PIN_MAP(1, 3)   // SCL signal pin
#define BAT_SDA_PIN             NRF_GPIO_PIN_MAP(0, 26)  // SDA signal pin

#ifdef __cplusplus
}
#endif

#endif // CUSTOM_BOARD_H
